<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-2014 Qualiteam software Ltd <info@x-cart.com>            |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Make patches
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Builder
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-2014 Qualiteam software Ltd <info@x-cart.com>. All rights reserved
 * @license    http://www.x-cart.com/license.php X-Cart license agreement
 * @version    $Id$
 * @link       http://www.x-cart.com/
 * @see        ____file_see____
 */

if ('cli' != php_sapi_name()) {
    echo 'Server API is NOT CLI' . PHP_EOL;
    exit(1);
}

# recursively remove a directory without files
function rrmdir($dir) {
    foreach(glob($dir . '/*') as $file) {
        if (is_dir($file))
            rrmdir($file);
    }
    @rmdir($dir);
}

array_shift($_SERVER['argv']);
$prefix = array_shift($_SERVER['argv']);

chdir(dirname(__FILE__) . '/../..');

$excludePattern = '/(?:\.git|Chuck_Norris\/.+)/Ss';

// Get versions
$versions = array();

/*
foreach (glob('*') as $file) {
    if (is_dir($file) && preg_match('/^(\d+\.\d+\.\d+)$/Ss', $file, $m)) {
        $versions[] = $m[1];
    }
}*/
$versions = array($_SERVER['argv'][0]);

$cur_dir = getcwd() . DIRECTORY_SEPARATOR;
foreach ($versions as $version) {

    $orig = 'orig/' . $version;
    $changed = $version;
    $out = 'releases/' . $version . '/' . $prefix . '.patches';
    if (!file_exists($out)) {
        mkdir($out, 0755, true);
        file_put_contents($out . '/.htaccess', 'Deny from all' . PHP_EOL);
    }
    $copyBase = 'releases/' . $version;
    $copy = 'releases/' . $version . '/' . $prefix . '.copy';
    if (!file_exists($copy)) {
        mkdir($copy, 0755, true);
        file_put_contents($copy . '/.htaccess', 'Deny from all' . PHP_EOL);
    }

    $changedLength = strlen(realpath($changed)) + 1;

    $iterator = new RecursiveIteratorIterator(
        new RecursiveDirectoryIterator($changed . DIRECTORY_SEPARATOR),
        RecursiveIteratorIterator::CHILD_FIRST
    );

    foreach ($iterator as $path => $file) {
        $path = realpath($path);
        if (is_file($path) && !preg_match($excludePattern, $file)) {
            $rpath = substr($path, $changedLength);

            if (
                !file_exists($orig . DIRECTORY_SEPARATOR . $rpath)
                // skip files like releases/4.6.1/skin/common_files/admin/home.tpl removed in build.xml
                || !file_exists($copyBase . DIRECTORY_SEPARATOR . $rpath)
            ) {
                continue;
            }

            echo 'Diff ' . $orig . DIRECTORY_SEPARATOR .  $rpath . PHP_EOL;

            // Create path
            $cmd = 'diff -u ' . $orig . DIRECTORY_SEPARATOR . $rpath . ' ' . $path;
            $patch = shell_exec($cmd);

            // Preprocess path
            $patch = preg_replace('/^--- orig\/[^\/]+\//Sm', '--- ', $patch);
            $patch = preg_replace(
                '/^--- (\S+)\s.+/Sm',
                'Index: \1' . "\n"
                . '===================================================================' . "\n"
                . 'diff -u \1'
                . "\n" . '--- \1',
                $patch
            );
            $patch = preg_replace('/^\+\+\+ .+changes\.[^\/]+\//Sm', '+++ ', $patch);
            $patch = preg_replace("/^\+\+\+ " .preg_quote($cur_dir . $version . DIRECTORY_SEPARATOR, '/'). "/Sm", '+++ ', $patch);
            $patch = preg_replace('/^(\+\+\+ \S+)\s.+$/Sm', '\1', $patch);
            $patch = preg_replace('/@@ -.+-\$Id:: .+@@ /USs', '@@ ', $patch);
            // Save path
            if (!file_exists($out . '/' . dirname($rpath))) {
                mkdir($out . '/' . dirname($rpath), 0755, true);
            }
            file_put_contents($out . '/' . $rpath . '.patch', $patch);

            // Copy original file
            if (!file_exists($copy . '/' . dirname($rpath))) {
                mkdir($copy . '/' . dirname($rpath), 0755, true);
            }
            copy($path, $copy . '/' . $rpath);

            $rmPath = $copyBase . DIRECTORY_SEPARATOR
                . preg_replace('/^.+' . preg_quote(DIRECTORY_SEPARATOR . $changed . DIRECTORY_SEPARATOR, '/'). '/Ss', '', $path);

            unlink($rmPath);
            if (!glob(dirname($rmPath) . '/*')) {
                // if dir is empty then delete it
                $dir = dirname($rmPath);
                $security = 7;

                do {
                    rrmdir($dir);
                    $dir = preg_replace('%/[^/]*$%', '', $dir);
                    $security--;

                } while (
                    !empty($dir)
                    && $security > 0
                    && ($dir != 'releases/' . $version)
                    && trim($dir, '/') != 'releases'
                    && trim($dir, '/') != 'aim'
                );
            }
        }
    }
}
