<?php
/* vim: set ts=4 sw=4 sts=4 et: */
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| X-Cart Software license agreement                                           |
| Copyright (c) 2001-2014 Qualiteam software Ltd <info@x-cart.com>            |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://www.x-cart.com/license.php                     |
|                                                                             |
| THIS AGREEMENT EXPRESSES THE TERMS AND CONDITIONS ON WHICH YOU MAY USE THIS |
| SOFTWARE PROGRAM AND ASSOCIATED DOCUMENTATION THAT QUALITEAM SOFTWARE LTD   |
| (hereinafter referred to as "THE AUTHOR") OF REPUBLIC OF CYPRUS IS          |
| FURNISHING OR MAKING AVAILABLE TO YOU WITH THIS AGREEMENT (COLLECTIVELY,    |
| THE "SOFTWARE"). PLEASE REVIEW THE FOLLOWING TERMS AND CONDITIONS OF THIS   |
| LICENSE AGREEMENT CAREFULLY BEFORE INSTALLING OR USING THE SOFTWARE. BY     |
| INSTALLING, COPYING OR OTHERWISE USING THE SOFTWARE, YOU AND YOUR COMPANY   |
| (COLLECTIVELY, "YOU") ARE ACCEPTING AND AGREEING TO THE TERMS OF THIS       |
| LICENSE AGREEMENT. IF YOU ARE NOT WILLING TO BE BOUND BY THIS AGREEMENT, DO |
| NOT INSTALL OR USE THE SOFTWARE. VARIOUS COPYRIGHTS AND OTHER INTELLECTUAL  |
| PROPERTY RIGHTS PROTECT THE SOFTWARE. THIS AGREEMENT IS A LICENSE AGREEMENT |
| THAT GIVES YOU LIMITED RIGHTS TO USE THE SOFTWARE AND NOT AN AGREEMENT FOR  |
| SALE OR FOR TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS NOT EXPRESSLY  |
| GRANTED BY THIS AGREEMENT.                                                  |
|                                                                             |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Functions of the 'Chuck_Norris System' module
 *
 * @category   X-Cart
 * @package    X-Cart
 * @subpackage Modules
 * @author     Ruslan R. Fazlyev <rrf@x-cart.com>
 * @copyright  Copyright (c) 2001-2014 Qualiteam software Ltd <info@x-cart.com>. All rights reserved
 * @license    http://www.x-cart.com/license.php X-Cart license agreement
 * @version    $Id$
 * @link       http://www.x-cart.com/
 * @see        ____file_see____
 */

if ( !defined('XCART_SESSION_START') ) { header('Location: ../'); die('Access denied'); }

class XCChuckNorrisTpl {

    public static function getJoke() {// {{{
        global $user_account, $sql_tbl, $cn_last_joke;

        if (
            empty($user_account['id'])
            || !func_user_is_cn_operator($user_account)
        ) {
            return '';
        }

        x_session_register('cn_last_joke');

        if (
            !empty($cn_last_joke)
            && (XC_TIME % 5) > 0 // For performance
        ) {
            return $cn_last_joke;
        }

        // $data_url = "http://api.icndb.com/jokes/random?firstName=$user_account[firstname]&lastName=$user_account[lastname]";
        // Use Norris firstname
        $data_url = 'http://api.icndb.com/jokes/random?firstName=' . urlencode($user_account['firstname']);

        if (
            !is_url($data_url)
            || !empty($_COOKIE['skip_remote_feeds'])
        ) {
            return array();
        }

        $data_url = parse_url($data_url);

        x_load('http');
        list($header, $result) = func_http_get_request($data_url['host'], $data_url['path'], @$data_url['query']);
        
        if (
            empty($header)
            && function_exists('func_temporarely_disable_remote_feeds') // Backward compatibility with 4.6.0/1
        ) {
            func_temporarely_disable_remote_feeds();
        }

        $data = (array)json_decode($result);

        $joke = $data['value']->joke;
        if (empty($joke)) {
            return '';
        }

        // Save for stats
        db_query("INSERT INTO $sql_tbl[cn_displayed_messages] VALUES ('$user_account[id]', '".addslashes($joke)."')");

        $cn_last_joke = $joke;
        x_session_save('cn_last_joke');
        return $cn_last_joke;
    } // }}}

    public static function registerSmartyFunctions($mode = '') {// {{{
        global $smarty;

        $smarty->register_function('cn_get_joke', array('XCChuckNorrisTpl','getJoke'));
        return true;
    } // }}}
}

function func_user_is_cn_operator($user_account) { // {{{
    global $current_area;

    if (empty($user_account)) {
        return false;
    }

    return !empty($user_account['cn_operator']) || in_array($current_area, array('A', 'P'));
} //}}}

/**
 * Get all payment for  Main page :: General settings :: Chuck_Norris system for X-Cart configuration page xcart_config.cn_paymentid.
 */
function func_cn_get_available_payment_methods() { // {{{
    global $sql_tbl;

    $methods = array();
    $db_methods = func_query_hash("SELECT paymentid, payment_method FROM $sql_tbl[payment_methods] WHERE active='Y' ORDER BY orderby", 'paymentid', false, true);

    $methods = empty($db_methods) ? $methods : ($methods + $db_methods);

    return $methods;
} //}}}

function func_set_cn_operator_checkbox($query_data) { // {{{
    if (!empty($query_data['cn_operator'])) {
        $query_data['cn_operator'] = 1;
    } else {
        $query_data['cn_operator'] = 0;
    }

    return $query_data;
} //}}}


function func_chuck_norris_init() { // {{{
    global $smarty, $PHP_SELF, $config;

    $area = (defined('AREA_TYPE')) ? AREA_TYPE : '';
    if (in_array($area, array('A','P'))) {
        // For module configuration page
        if (isset($_GET['option']) && $_GET['option'] == 'Chuck_Norris') {
            $smarty->assign('additional_config', 'modules/Chuck_Norris/config.tpl');
        }
    } 

    // For home page 
    if (basename($PHP_SELF) == 'home.php') {
        XCChuckNorrisTpl::registerSmartyFunctions();
    }
} //}}}

?>
